import { select , geoMercator, json, geoPath, event,zoom } from 'd3';
const width = document.body.clientWidth;
const height = document.body.clientHeight;
const svg = select('svg').attr('width', width).attr('height', height);
const g = svg.append('g');
const mercator = geoMercator().scale(30000).translate([width/2, height/2]).center([73,19.7]);
const pathGenerator = geoPath().projection(mercator);
//Zoom
svg.call(zoom().on('zoom',() =>{
	g.attr('transform',event.transform)
}))
//Reading data

const render = data => {
  console.log(data);
let c1Value  = d => d.properties.c1;
const min = d3.min(data,c1Value);
const max = d3.max(data,c1Value);
const comp = (max - min)/3;
// Define the div for the tooltip
const onMouseOver = d =>{	
tooltip.transition().duration(200).style("opacity", .9);		
tooltip.html("<b>"+d.properties.Block+"</b><br><b>Stunted child:</b>"+d.properties.c1+"%")
    .style("left", d3.event.pageX + "px")
    .style("top",  d3.event.pageY - 30 + "px");	
}
 var tooltip = d3.select("body").append("div") 
        .attr("class", "tooltip")       
        .style("opacity", 0);

var myColor = (v,low,high) =>{
  if(v<low)
    return 'red';
  else if(v >= low && v <= high)
    return 'yellow';
  else if(v>high)
    return 'green';
} 
  
	const paths = g.selectAll('path').data(data);
 
  const pathEnter = paths.enter().append('path').attr('d',pathGenerator).attr('class','boundary')
  .style("fill", function(d) {
      var value = d.properties.c1;
      return myColor(value,min+comp,max-comp); 
		}).on("mouseover", d => onMouseOver(d))          
      .on("mouseout", function(d) {   
            tooltip.transition()    
            .duration(500)    
            .style("opacity", 0); 
          });
  
  
   g.selectAll("text").data(data)
    .enter().append("text")
    .text(d => d.properties.Block)
    .attr("x", function(d){
        return pathGenerator.centroid(d)[0];
    })
    .attr("y", function(d){
        return  pathGenerator.centroid(d)[1];
    })
    .attr("text-anchor","middle")
    .attr('font-size','12pt')
    .attr("font-family", "sans-serif");
  const fillSlider = () =>{
  leftX2 = +d3.select('line.track-fill').attr("x1")-15;
  d3.select('line.leftcolor').attr('x2',leftX2);
    if(leftX2<0)
                select('line.leftcolor').attr('stroke','rbg(0,0,0,0)')
            else
                select('line.leftcolor').attr('stroke','red')
  }


  sliderRange .on('onchange', val => {
    fillSlider();
    d3.select('p#value-range').text(val.map(d3.format('.1%')).join('-'));
    const tansitionDuration = 1000;
      let low = (val[0]*100).toFixed(2);
      let high = (val[1]*100).toFixed(2);
			pathEnter.transition().duration(tansitionDuration).style("fill", function(d) {
      	return myColor(c1Value(d),low,high);
				})
    })
}
d3.csv("data.csv").then(data =>{
  d3.json('block.geojson').then(json =>{
    for (var i = 0; i < data.length; i++) {
    	var dataBlock = data[i].Block;
      var datac1 = data[i].c1;
      
    for (var j = 0; j < json.features.length; j++)  {
        var jsonBlock = json.features[j].properties.Block;

        if (dataBlock == jsonBlock) {
        json.features[j].properties.c1 = +datac1; 
        break;
      }
    }
    }
    render(json.features);
  })
})


//Range slider

var sliderRange = d3
    .sliderBottom()
    .min(0)
    .max(.999)
    .width(300)
    .tickFormat(d3.format('.1%'))
    .ticks(5)
    .default([.25, .50])
    .fill('yellow')
    .handle(d3.symbol().type(d3.symbolCircle).size(550)());

  var gRange = d3
    .select('div#slider-range')
    .append('svg')
    .attr('width', 500)
    .attr('height', 100)
    .append('g')
    .attr('transform', 'translate(30,30)');

  gRange.call(sliderRange);

  d3.select('p#value-range').text(
    sliderRange
      .value()
      .map(d3.format('.1%'))
      .join('-')
  );

let leftX1 = +d3.select('line.track-inset').attr("x1");
let leftX2 = +d3.select('line.track-fill').attr("x1")-15;
d3.select('g.slider').append('line').attr('class','leftcolor')
  .attr('x1',leftX1).attr('x2',leftX2)
	.attr('stroke-width',4).attr('stroke-linecap','round');

d3.select('line.track-fill').attr('stroke','yellow')
d3.select('line.leftcolor').attr('stroke','red')
d3.select('line.track-inset').attr('stroke','green')







